/*
 * timer.hpp
 *
 *  Created on: 10 . 2023 .
 *      Author: sychev
 */

#ifndef FREE_RTOS_TIMER_TIMER_HPP_
#define FREE_RTOS_TIMER_TIMER_HPP_

#include <semaphore/semaphore.hpp>
#include <cstdint>
#include <kernel/dpl/HwiP.h>



namespace free_rtos {

class Timer {
public:
    struct Settings {
        uint32_t input_clk_Hz;       ///    
        uint32_t base_address;       ///  
        uint32_t clock_src_mux_addr; ///  
        uint32_t int_num;            ///  
        uint32_t int_priority;       ///  
        uint32_t period_us;          ///    
    };

    /**
     *  
     */
    bool Init(Settings& sett);

    /**
     *   . .
     */
    void Wait();

    void Start();

    void Stop();
private:
    friend void timer_isr_callback(void * arg);

private:
    uint32_t    base_addr_;   ///    
    uint32_t    int_num_;     ///  
    HwiP_Object hwi_obj_;     ///    

    Semaphore sem_;
};

}

#endif /* FREE_RTOS_TIMER_TIMER_HPP_ */
